'use strict';

var componentLib = require('./component');
var StaticsMixin = require('./statics-mixin');
var ComponentRenderMixin = require('./component-render-mixin');

function subedit(edit) {
  for (var _len = arguments.length, path = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    path[_key - 1] = arguments[_key];
  }

  return function (transform) {
    return edit(function (state) {
      return state.updateIn(path, transform);
    });
  };
}

var elegant = function elegant(React) {
  var component = componentLib(React);

  var lib = {
    subedit: subedit,
    StaticsMixin: StaticsMixin,
    ComponentRenderMixin: ComponentRenderMixin,
    component: component.component
  };

  var elegantReact = function elegantReact(options) {
    if (options && options.hasOwnProperty('debug')) {
      component.enableDebugging(options.debug);
    }

    return lib;
  };

  for (var k in lib) {
    elegantReact[k] = lib[k];
  }

  return elegantReact;
};

module.exports = elegant;